﻿using UnityEngine;
using System.Collections;

public class Button : MonoBehaviour {

	public Vector3 PushOffset = new Vector3(0,-1,0);
	public float DownTime = 3.0f;
	public GameObject Target;
	float TimeRemaining;
	public int RequiredPlayerNumber = 0;

	// Use this for initialization
	void Start () {
	
	}
	
	// Update is called once per frame
	void Update () {
		if (TimeRemaining > 0)
		{
			TimeRemaining -= Time.deltaTime;
			if (TimeRemaining <= 0)
			{
				Target.SendMessage("UnTrigger");
				TimeRemaining = 0;
				transform.position -= PushOffset;
			}
		}
	}

	void OnTriggerEnter(Collider other)
	{
		if (0 != RequiredPlayerNumber)
		{
			PlayerInfo player = other.GetComponent(typeof(PlayerInfo)) as PlayerInfo;
			if (null == player || player.PlayerNumber != RequiredPlayerNumber)
			{
				return;
			}
		}

		Debug.Log ("Button Trigger");
		TimeRemaining = DownTime;
		Target.SendMessage ("Trigger");
		transform.position += PushOffset;
	}
}
