﻿using UnityEngine;
using System.Collections;

public class Mover : MonoBehaviour {

	public Transform StartPoint;
	public Transform EndPoint;
	public float Period = 4;
	public int Direction = 1;
	public bool Started = true;
	public bool StopAtTarget = false;

	// Use this for initialization
	void Start () {
		transform.position = StartPoint.position;
	}
	
	// Update is called once per frame
	void Update () {
		if (Started)
			DoMover();
	}

	void DoMover()
	{
		Transform source = (1 == Direction) ? StartPoint : EndPoint;
		Transform target = (-1 == Direction) ? StartPoint : EndPoint;

		Vector3 path = target.position - source.position;
		float pathLen = path.magnitude;
		Vector3 pathNormalized = path.normalized;
		Vector3 toTarg = target.position - transform.position;
		float speed = pathLen * 2 / Period;
		float movement = speed * Time.deltaTime;
		if (toTarg.magnitude <= movement)
		{
			transform.position = target.position;
			Direction *= -1;
			if (StopAtTarget)
				Started = false;
		}
		else
		{
			transform.position += pathNormalized * movement;
		}
	}

	public void Trigger()
	{
		Started = true;
		Direction = 1;
	}
	
	public void UnTrigger()
	{
		Started = true;
		Direction = -1;
	}
}
