﻿using UnityEngine;
using System.Collections;

public class PlayerInput : MonoBehaviour {

	Vector3 Velocity;
	public float Acceleration = 10.0f;
	public Vector2 CameraSpeed = new Vector2(5.0f, 5.0f);
	public float CameraAcceleration = 10.0f;
	Vector2 CameraVelocity;
	
	CharacterController CC;
	GameObject Cam;

	// Use this for initialization
	void Start () {
		CC = GetComponent<CharacterController> ();
		Cam = transform.FindChild ("Main Camera").gameObject;
	}
	
	// Update is called once per frame
	void Update () {
		
		Vector2 camInput = new Vector2(Input.GetAxis("Horizontal"), Input.GetAxis("Vertical"));
		Vector2 desiredCamVelocity = new Vector2(camInput.x * CameraSpeed.x, camInput.y * CameraSpeed.y);
		CameraVelocity = Vector2.Lerp (CameraVelocity, desiredCamVelocity, CameraAcceleration * Time.deltaTime);
		
		transform.Rotate (new Vector3 (0, CameraVelocity.x * Time.deltaTime, 0));
		Cam.transform.RotateAround(camera.transform.position, new Vector3(0,0,1), CameraVelocity.y * Time.deltaTime);

		float h = 0;
		if (Input.GetKey("d"))
			h++;
		if (Input.GetKey("a"))
			h--;
		float v = 0;
		if (Input.GetKey("w"))
			v++;
		if (Input.GetKey("s"))
			v--;

		Vector3 movementInput = new Vector3 (h, 0, v);
		Velocity = Vector3.Lerp(Velocity, movementInput, Acceleration * Time.deltaTime);
		CC.Move (Velocity);
	}
}
